# This file is a template, and might need editing before it works on your project.
# To contribute improvements to CI/CD templates, please follow the Development guide at:
# https://docs.gitlab.com/ee/development/cicd/templates.html
# This specific template is located at:
# https://gitlab.com/gitlab-org/gitlab/-/blob/master/lib/gitlab/ci/templates/Getting-Started.gitlab-ci.yml

# This is a sample GitLab CI/CD configuration file that should run without any modifications.
# It demonstrates a basic 3 stage CI/CD pipeline. Instead of real tests or scripts,
# it uses echo commands to simulate the pipeline execution.
#
# A pipeline is composed of independent jobs that run scripts, grouped into stages.
# Stages run in sequential order, but jobs within stages run in parallel.
#
# For more information, see: https://docs.gitlab.com/ee/ci/yaml/index.html#stages

before_script:
  - npm install

stages:          # List of stages for jobs, and their order of execution
  - build
  - test
  - deploy

build-code:
  image: node:16.13.0
  stage: build
  script:
    - npm run build
    - echo "Compile complete."

unit-test-job:   # This job runs in the test stage.
  image: node:16.13.0
  stage: test    # It only starts when the job in the build stage completes successfully.
  script:
    - npm run test 

lint-test-job:   # This job also runs in the test stage.
  image: node:16.13.0
  stage: test    # It can run at the same time as unit-test-job (in parallel).
  script:
    - npm run lint

deploy-job:      # This job runs in the deploy stage.
  stage: deploy  # It only runs when *both* jobs in the test stage complete successfully.
  script:
    - echo "Deploying application..."
    - echo "Application successfully deployed."
